<template>
	<BlankLayout>
		<template slot="head">
			<CommonHeader :showBackButton="true" :title="$t('deliveryAddress')"></CommonHeader>
		</template>
		<template slot="body">
			<div class="send-form">
				<div class="form-group" style="grid-row: 1; grid-column: 1 / 3;">
					<span class="label">{{ $t('street') }}</span>
					<input 
						name="street"  
						type="text" 
						class="form-control bee-input" 
						v-model.trim="address.street"
						:placeholder="$t('streetPH')" />
					<span v-if="formErrors.street" class="error">{{ $t('streetPHError') }}</span>
				</div>
				<div class="form-group" style="grid-row: 2; grid-column: 1 / 2;">
					<span class="label">{{ $t('numExt') }}</span>
					<input 
						name="street" 
						type="text" 
						class="form-control bee-input" 
						v-model.trim="address.extNumber"
						:placeholder="$t('numIntPH')" />
						<span v-if="formErrors.extNumber" class="error">{{ $t('numIntPHError') }}</span>
				</div>
				<div class="form-group" style="grid-row: 2; grid-column: 2 / 2;">
					<span class="label">{{ $t('numInt') }}</span>
					<input 
						name="street"
						type="text" 
						class="form-control bee-input" 
						v-model.trim="address.number"
						:placeholder="$t('numIntPH')" />
				</div>
				<div class="form-group" style="grid-row: 3; grid-column: 1 / 3;">
					<span class="label">{{ $t('cpp') }}</span>
					<input 
						name="street" 
						type="number" 
						class="form-control bee-input" 
						v-model.trim="address.postal"
						:placeholder="$t('cppPH')" />
						<span v-if="formErrors.postal" class="error">{{ $t('cppPHError') }}</span>
				</div>
				<div class="form-group" style="grid-row: 4; grid-column: 1 / 3;">
					<span class="label">{{ $t('suburb') }}</span>
					<input 
						name="street" 
						type="text" 
						class="form-control bee-input" 
						v-model.trim="address.region"
						:placeholder="$t('suburbPH')" />
						<span v-if="formErrors.region" class="error">{{ $t('suburbPHError') }}</span>
				</div>
				<div class="form-group" style="grid-row: 5; grid-column: 1 / 3;">
					<span class="label">{{ $t('references') }}</span>
					<input 
						name="street" 
						type="text" 
						class="form-control bee-input" 
						v-model.trim="address.references"
						:placeholder="$t('referencesPH')" />
						<span v-if="formErrors.references" class="error">{{ $t('referencesPHError') }}</span>
				</div>
				<div class="form-group" style="grid-row: 6; grid-column: 1 / 2;">
					<span class="label">{{ $t('telephone') }}</span>
					<input
						name="street"
						type="text"
						class="form-control bee-input"
						v-model.trim="phone"
						:placeholder="$t('telephonePlaceholder')">
						<span v-if="formErrors.phone" class="error">{{ $t('referencesPHError') }}</span>
				</div>
				<div class="form-group" style="grid-row: 6; grid-column: 2 / 2;">
					<span class="label">{{ $t('telephoneExt') }}</span>
					<input 
					name="street" 
					type="text" 
					class="form-control bee-input" 
					v-model.trim="extPhone"
					:placeholder="$t('optional')" />
				</div>
				<!-- <div class="form-group" style="grid-row: 7; grid-column: 1 / 3;">
					<span class="label">{{ $t('addressAlias') }}</span>
					<input
						name="street"
						type="text"
						class="form-control bee-input"
						:placeholder="$t('addressAliasPH')"
					/>
				</div> -->
				<div class="form-group" style="grid-row: 8; grid-column: 1 / 3;">
					<BeeInput @click="saveForm()" class="add">{{ $t('continue') }}</BeeInput>
				</div>
			</div>
		</template>
	</BlankLayout>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import BlankLayout from '@/layouts/BlankLayout.vue'
import BeeInput from '@/components/BeeInput.vue'
import Address from '@/models/Address'
import { StatusDelivery } from '@/models/Order'

@Component({
	components: {
		BeeInput,
		BlankLayout,
		CommonHeader
	}
})
export default class DeliveryFrom extends Vue {
	address: Address = this.$store.state.address
	phone: string = this.$store.state.order.phone
	extPhone = ''
	formErrors = {
		street: false,
		intNumber: false,
		extNumber: false,
		postal: false,
		region: false,
		references: false,
		phone: false,
	}

	async saveForm(){
		if (!this.validForm()) return;
		this.$store.state.order.address = this.address
		this.$store.state.order.phone = this.phone
		this.$store.state.order.phoneExt = this.extPhone
		this.$store.state.order.statusDelivery = StatusDelivery.SUMMARY

		this.$analytics.logEvent('add_shipping_info', {
			currency: this.$store.state.order.currency,
			value: this.$store.state.order.subtotal + this.$store.state.order.deliveryCost,
				items: this.$store.state.order.items.map(item => ({
				item_id: item.id,
				item_name: item.name,
				quantity: item.quantity,
				price: Number(item.price),
				item_category: item.category,
				item_category2: item.subcategory,
				item_brand: this.$store.state.menu.name,
				affiliation: this.$store.state.typeOrder
			}))
		})

		this.$router.push('/summary')
	}

	validForm(): boolean {
		this.formErrors = { street: false, 
			intNumber: false, 
			extNumber: false, 
			postal: false,
			region: false,
			references: false,
			phone: false,
		};
		if (!this.address.street) this.formErrors.street = true;
		if (!this.address.extNumber) this.formErrors.extNumber = true;
		if (!this.address.postal) this.formErrors.postal = true;
		if (!this.address.region) this.formErrors.region = true;
		if (!this.address.references) this.formErrors.references = true;
		if (!this.phone) this.formErrors.phone = true;

		for (const error of Object.values(this.formErrors)) {
			if (error == true) {
				return false;
			}
		}
		return true;
	}
}
</script>
<style lang="scss" scoped>
.send-form {
	color: black;
	font-family: 'Roboto Condensed';
	display: grid;
	margin: 10px;
	grid-gap: 1% 10%;

	.form-group {
		margin: 5px;

		.label {
			font-weight: 600;
			font-size: 15px;
		}

		.bee-input {
            box-sizing: content-box;
			position: relative;
			margin-top: 5px;
			text-indent: 5px;
			font-size: 15px;
			height: 40px;
		}
	}

	.error {
      font-size: 12px;
      color: red;
      margin: auto;
    }
}
.add {
	color: white !important;
	font-size: 120%;
	width: 100%;
	position: relative;
}
</style>
